Index: branches/OKB/HeuristicLab.Services.OKB/3.3/ExperimentEqualityComparer.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB/3.3/ExperimentEqualityComparer.cs	(revision 4591)
+++ branches/OKB/HeuristicLab.Services.OKB/3.3/ExperimentEqualityComparer.cs	(revision 4591)
@@ -0,0 +1,132 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB {
+  public class ExperimentEqualityComparer : IEqualityComparer<Experiment> {
+    public bool Equals(Experiment x, Experiment y) {
+      bool equal = true;
+      equal = equal && x.AlgorithmId == y.AlgorithmId;
+      equal = equal && x.ProblemId == y.ProblemId;
+      equal = equal && x.AlgorithmParameterBlobValues.Count == y.AlgorithmParameterBlobValues.Count;
+      equal = equal && x.AlgorithmParameterBoolValues.Count == y.AlgorithmParameterBoolValues.Count;
+      equal = equal && x.AlgorithmParameterFloatValues.Count == y.AlgorithmParameterFloatValues.Count;
+      equal = equal && x.AlgorithmParameterIntValues.Count == y.AlgorithmParameterIntValues.Count;
+      equal = equal && x.AlgorithmParameterStringValues.Count == y.AlgorithmParameterStringValues.Count;
+      equal = equal && x.ProblemParameterBlobValues.Count == y.ProblemParameterBlobValues.Count;
+      equal = equal && x.ProblemParameterBoolValues.Count == y.ProblemParameterBoolValues.Count;
+      equal = equal && x.ProblemParameterFloatValues.Count == y.ProblemParameterFloatValues.Count;
+      equal = equal && x.ProblemParameterIntValues.Count == y.ProblemParameterIntValues.Count;
+      equal = equal && x.ProblemParameterStringValues.Count == y.ProblemParameterStringValues.Count;
+
+      if (equal) {
+        var values = x.AlgorithmParameterBlobValues.Zip(y.AlgorithmParameterBlobValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.AlgorithmParameterId == value.Y.AlgorithmParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value.Equals(value.Y.Value);
+        }
+      }
+      if (equal) {
+        var values = x.AlgorithmParameterBoolValues.Zip(y.AlgorithmParameterBoolValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.AlgorithmParameterId == value.Y.AlgorithmParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+      if (equal) {
+        var values = x.AlgorithmParameterFloatValues.Zip(y.AlgorithmParameterFloatValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.AlgorithmParameterId == value.Y.AlgorithmParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+      if (equal) {
+        var values = x.AlgorithmParameterIntValues.Zip(y.AlgorithmParameterIntValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.AlgorithmParameterId == value.Y.AlgorithmParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+      if (equal) {
+        var values = x.AlgorithmParameterStringValues.Zip(y.AlgorithmParameterStringValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.AlgorithmParameterId == value.Y.AlgorithmParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+
+      if (equal) {
+        var values = x.ProblemParameterBlobValues.Zip(y.ProblemParameterBlobValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.ProblemParameterId == value.Y.ProblemParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value.Equals(value.Y.Value);
+        }
+      }
+      if (equal) {
+        var values = x.ProblemParameterBoolValues.Zip(y.ProblemParameterBoolValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.ProblemParameterId == value.Y.ProblemParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+      if (equal) {
+        var values = x.ProblemParameterFloatValues.Zip(y.ProblemParameterFloatValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.ProblemParameterId == value.Y.ProblemParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+      if (equal) {
+        var values = x.ProblemParameterIntValues.Zip(y.ProblemParameterIntValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.ProblemParameterId == value.Y.ProblemParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+      if (equal) {
+        var values = x.ProblemParameterStringValues.Zip(y.ProblemParameterStringValues, (a, b) => new { X = a, Y = b });
+        foreach (var value in values) {
+          equal = equal && value.X.ProblemParameterId == value.Y.ProblemParameterId;
+          equal = equal && value.X.DataTypeId == value.Y.DataTypeId;
+          equal = equal && value.X.Value == value.Y.Value;
+        }
+      }
+
+      return equal;
+    }
+
+    public int GetHashCode(Experiment obj) {
+      return obj.GetHashCode();
+    }
+  }
+}
Index: branches/OKB/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 4587)
+++ branches/OKB/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 4591)
@@ -122,4 +122,5 @@
     <Compile Include="Convert.cs" />
     <Compile Include="AuthenticationService.cs" />
+    <Compile Include="ExperimentEqualityComparer.cs" />
     <Compile Include="Interfaces\IAuthenticationService.cs" />
     <Compile Include="Interfaces\IOKBService.cs" />
Index: branches/OKB/HeuristicLab.Services.OKB/3.3/Interfaces/IOKBService.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB/3.3/Interfaces/IOKBService.cs	(revision 4587)
+++ branches/OKB/HeuristicLab.Services.OKB/3.3/Interfaces/IOKBService.cs	(revision 4591)
@@ -170,4 +170,26 @@
     void DeleteResult(long id);
     #endregion
+
+    #region Experiment Methods
+    [OperationContract]
+    Experiment GetExperiment(long id);
+    [OperationContract]
+    IEnumerable<Experiment> GetExperiments(long algorithmId, long problemId);
+    [OperationContract]
+    long AddExperiment(Experiment dto);
+    [OperationContract]
+    void DeleteExperiment(long id);
+    #endregion
+
+    #region Run Methods
+    [OperationContract]
+    Run GetRun(long id);
+    [OperationContract]
+    IEnumerable<Run> GetRuns(long experimentId);
+    [OperationContract]
+    long AddRun(Run dto);
+    [OperationContract]
+    void DeleteRun(long id);
+    #endregion
   }
 }
Index: branches/OKB/HeuristicLab.Services.OKB/3.3/OKBService.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB/3.3/OKBService.cs	(revision 4587)
+++ branches/OKB/HeuristicLab.Services.OKB/3.3/OKBService.cs	(revision 4591)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Data.Linq;
 using System.Linq;
 using System.ServiceModel;
@@ -398,4 +399,126 @@
         DataAccess.Result entity = okb.Results.FirstOrDefault(x => x.Id == id);
         if (entity != null) okb.Results.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
+      }
+    }
+    #endregion
+
+    #region Experiment Methods
+    public DataTransfer.Experiment GetExperiment(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataLoadOptions dlo = new DataLoadOptions();
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterStringValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterStringValues);
+        okb.LoadOptions = dlo;
+        return Convert.ToDto(okb.Experiments.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.Experiment> GetExperiments(long algorithmId, long problemId) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataLoadOptions dlo = new DataLoadOptions();
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterStringValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterStringValues);
+        okb.LoadOptions = dlo;
+        if ((algorithmId != 0) && (problemId != 0))
+          return okb.Experiments.Where(x => (x.AlgorithmId == algorithmId) && (x.ProblemId == problemId)).Select(x => Convert.ToDto(x)).ToArray();
+        else if (algorithmId != 0)
+          return okb.Experiments.Where(x => x.AlgorithmId == algorithmId).Select(x => Convert.ToDto(x)).ToArray();
+        else if (problemId != 0)
+          return okb.Experiments.Where(x => x.ProblemId == problemId).Select(x => Convert.ToDto(x)).ToArray();
+        else
+          return okb.Experiments.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public long AddExperiment(DataTransfer.Experiment dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Experiment entity = Convert.ToEntity(dto); entity.Id = 0;
+
+        DataLoadOptions dlo = new DataLoadOptions();
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterStringValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterStringValues);
+        okb.LoadOptions = dlo;
+
+        var experiments = okb.Experiments.Where(x => ((x.AlgorithmId == entity.AlgorithmId) && (x.ProblemId == entity.ProblemId)));
+        ExperimentEqualityComparer comparer = new ExperimentEqualityComparer();
+        Experiment exp = experiments.FirstOrDefault(x => comparer.Equals(x, entity));
+        if (exp != null) {
+          return exp.Id;
+        } else {
+          okb.Experiments.InsertOnSubmit(entity);
+          okb.SubmitChanges();
+          return entity.Id;
+        }
+      }
+    }
+    public void DeleteExperiment(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Experiment entity = okb.Experiments.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.Experiments.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
+      }
+    }
+    #endregion
+
+    #region Run Methods
+    public DataTransfer.Run GetRun(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataLoadOptions dlo = new DataLoadOptions();
+        dlo.LoadWith<Run>(x => x.ResultBlobValues);
+        dlo.LoadWith<Run>(x => x.ResultBoolValues);
+        dlo.LoadWith<Run>(x => x.ResultFloatValues);
+        dlo.LoadWith<Run>(x => x.ResultIntValues);
+        dlo.LoadWith<Run>(x => x.ResultStringValues);
+        okb.LoadOptions = dlo;
+        return Convert.ToDto(okb.Runs.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.Run> GetRuns(long experimentId) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataLoadOptions dlo = new DataLoadOptions();
+        dlo.LoadWith<Run>(x => x.ResultBlobValues);
+        dlo.LoadWith<Run>(x => x.ResultBoolValues);
+        dlo.LoadWith<Run>(x => x.ResultFloatValues);
+        dlo.LoadWith<Run>(x => x.ResultIntValues);
+        dlo.LoadWith<Run>(x => x.ResultStringValues);
+        okb.LoadOptions = dlo;
+        return okb.Runs.Where(x => x.ExperimentId == experimentId).Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public long AddRun(DataTransfer.Run dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Run entity = Convert.ToEntity(dto); entity.Id = 0;
+        okb.Runs.InsertOnSubmit(entity);
+        okb.SubmitChanges();
+        return entity.Id;
+      }
+    }
+    public void DeleteRun(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Run entity = okb.Runs.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.Runs.DeleteOnSubmit(entity);
         okb.SubmitChanges();
       }
